﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace FocusSample
{
    class ViewModel
    {
        public ObservableCollection<Item> ItemList { get; private set; }

        public ViewModel()
        {
            ItemList = new ObservableCollection<Item>
                           {
                               new Item("data11", "data12"),
                               new Item("data21", "data22"),
                               new Item("data31", "data32"),
                           };
        }

        // INotifyPropertyChanged interface implementation
        #region INotifyPropertyChanged interface implementation

        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion
    }

    
    class Item : INotifyPropertyChanged
    {
        // data
        #region data

        private string _data1;
        public string Data1
        {
            get { return _data1; }
            set
            {
                _data1 = value;
                RaisePropertyChanged("Data1");
            }
        }

        private string _data2;
        public string Data2
        {
            get { return _data2; }
            set
            {
                _data2 = value;
                RaisePropertyChanged("Data2");
            }
        }

        #endregion

        // contructor
        public Item(string data1, string data2)
        {
            Data1 = data1;
            Data2 = data2;
        }

        // INotifyPropertyChanged interface implementation
        #region INotifyPropertyChanged interface implementation

        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion
    }
}
